diff --git a/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/utils.js b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/utils.js
new file mode 100644
index 000000000..ff8b4c563
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/utils.js
@@ -0,0 +1 @@
+export default {};
diff --git a/packages/code-generator/test-cases/rax-app/demo1/schema.json5 b/packages/code-generator/test-cases/rax-app/demo1/schema.json5
new file mode 100644
index 000000000..282f979e8
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo1/schema.json5
@@ -0,0 +1,55 @@
+{
+  // 本例是一个非常简单的 Hello world 页面
+  // Schema 参见：https://yuque.antfin-inc.com/mo/spec/spec-materials#eNCJr
+  version: '1.0.0',
+  componentsMap: [
+    {
+      componentName: 'Page',
+      package: 'rax-view',
+      version: '^1.0.0',
+      destructuring: false,
+      exportName: 'Page',
+    },
+    {
+      componentName: 'Text',
+      package: 'rax-text',
+      version: '^1.0.0',
+      destructuring: false,
+      exportName: 'Text',
+    },
+  ],
+  componentsTree: [
+    {
+      componentName: 'Page',
+      props: {},
+      lifeCycles: {},
+      fileName: 'home',
+      meta: {
+        router: '/',
+      },
+      dataSource: {
+        list: [],
+      },
+      children: [
+        {
+          componentName: 'Text',
+          props: {},
+          children: 'Hello world!',
+        },
+      ],
+    },
+  ],
+  config: {
+    sdkVersion: '1.0.3',
+    historyMode: 'hash',
+    targetRootID: 'root',
+  },
+  meta: {
+    name: 'Rax App Demo',
+    git_group: 'demo-group',
+    project_name: 'demo-project',
+    description: '这是一个示例应用',
+    spma: 'spmademo',
+    creator: '张三',
+  },
+}
diff --git a/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/.editorconfig b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/.editorconfig
new file mode 100644
index 000000000..5760be583
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/.editorconfig
@@ -0,0 +1,12 @@
+# http://editorconfig.org
+root = true
+
+[*]
+indent_style = space
+indent_size = 2
+charset = utf-8
+trim_trailing_whitespace = true
+insert_final_newline = true
+
+[*.md]
+trim_trailing_whitespace = false
diff --git a/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/.eslintignore b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/.eslintignore
new file mode 100644
index 000000000..3b437e614
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/.eslintignore
@@ -0,0 +1,11 @@
+# 忽略目录
+build/
+tests/
+demo/
+
+# node 覆盖率文件
+coverage/
+
+# 忽略文件
+**/*-min.js
+**/*.min.js
diff --git a/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/.eslintrc.js b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/.eslintrc.js
new file mode 100644
index 000000000..e2a7c5b54
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/.eslintrc.js
@@ -0,0 +1,3 @@
+module.exports = {
+  extends: ['rax'],
+};
diff --git a/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/.gitignore b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/.gitignore
new file mode 100644
index 000000000..50a53dace
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/.gitignore
@@ -0,0 +1,17 @@
+# See https://help.github.com/articles/ignoring-files/ for more about ignoring files.
+
+*~
+*.swp
+*.log
+
+.DS_Store
+.idea/
+.temp/
+
+build/
+dist/
+lib/
+coverage/
+node_modules/
+
+template.yml
diff --git a/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/app.js b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/app.js
new file mode 100644
index 000000000..bc474c6e3
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/app.js
@@ -0,0 +1,6 @@
+import { runApp } from 'rax-app';
+import appConfig from './app.json';
+
+import './global.scss';
+
+runApp(appConfig);
diff --git a/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/constants.js b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/constants.js
new file mode 100644
index 000000000..ea766c9da
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/constants.js
@@ -0,0 +1,3 @@
+const __$$constants = {};
+
+export default __$$constants;
diff --git a/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/document/index.jsx b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/document/index.jsx
new file mode 100644
index 000000000..50569a9b6
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/document/index.jsx
@@ -0,0 +1,25 @@
+import { createElement } from 'rax';
+import { Root, Style, Script } from 'rax-document';
+
+function Document() {
+  return (
+    <html>
+      <head>
+        <meta charset="utf-8" />
+        <meta
+          name="viewport"
+          content="width=device-width,initial-scale=1,maximum-scale=1,minimum-scale=1,user-scalable=no,viewport-fit=cover"
+        />
+        <title>Rax App Demo</title>
+        <Style />
+      </head>
+      <body>
+        {/* root container */}
+        <Root />
+        <Script />
+      </body>
+    </html>
+  );
+}
+
+export default Document;
diff --git a/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/i18n.js b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/i18n.js
new file mode 100644
index 000000000..8f0de31e0
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/i18n.js
@@ -0,0 +1,31 @@
+import IntlMessageFormat from 'intl-messageformat';
+
+const i18nConfig = {};
+
+let locale = 'en-US';
+
+const getLocale = () => locale;
+
+const setLocale = (target) => {
+  locale = target;
+};
+
+const i18nFormat = ({ id, defaultMessage }, variables) => {
+  const msg = (i18nConfig && i18nConfig[locale] && i18nConfig[locale][id]) || defaultMessage;
+  if (msg == null) {
+    console.warn('[i18n]: unknown message id: %o (locale=%o)', id, locale);
+    return `${id}`;
+  }
+
+  if (!variables || !variables.length) {
+    return msg;
+  }
+
+  return new IntlMessageFormat(msg, locale).format(variables);
+};
+
+const i18n = (id) => {
+  return i18nFormat({ id });
+};
+
+export { getLocale, setLocale, i18n, i18nFormat };
diff --git a/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/pages/Home/index.jsx b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/pages/Home/index.jsx
new file mode 100644
index 000000000..5b78b28a0
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/pages/Home/index.jsx
@@ -0,0 +1,340 @@
+// 注意: 出码引擎注入的临时变量默认都以 "__$$" 开头，禁止在搭建的代码中直接访问。
+// 例外：rax 框架的导出名和各种组件名除外。
+import { createElement, Component } from 'rax';
+import { withRouter as __$$withRouter } from 'rax-app';
+
+import View from 'rax-view';
+
+import Text from 'rax-text';
+
+import Image from 'rax-image';
+
+import { createUrlParamsHandler as __$$createUrlParamsRequestHandler } from '@ali/lowcode-datasource-url-params-handler';
+
+import { createFetchHandler as __$$createFetchRequestHandler } from '@ali/lowcode-datasource-fetch-handler';
+
+import { create as __$$createDataSourceEngine } from '@ali/lowcode-datasource-engine/runtime';
+
+import { isMiniApp as __$$isMiniApp } from 'universal-env';
+
+import __$$constants from '../../constants';
+
+import * as __$$i18n from '../../i18n';
+
+import __$$projectUtils from '../../utils';
+
+import './index.css';
+
+class Home$$Page extends Component {
+  state = {
+    clickCount: 0,
+    user: { name: '张三', age: 18, avatar: 'https://gw.alicdn.com/tfs/TB1Ui9BMkY2gK0jSZFgXXc5OFXa-50-50.png' },
+    orders: [
+      {
+        title: '【小米智能生活】米家扫地机器人家用全自动扫拖一体机拖地吸尘器',
+        price: 1799,
+        coverUrl: 'https://gw.alicdn.com/tfs/TB1dGVlRfb2gK0jSZK9XXaEgFXa-258-130.png',
+      },
+      {
+        title: '【限时下单立减】Apple/苹果 iPhone 11 4G全网通智能手机正品苏宁易购官方旗舰店苹果11',
+        price: 4999,
+        coverUrl: 'https://gw.alicdn.com/tfs/TB18gdJddTfau8jSZFwXXX1mVXa-1298-1202.png',
+      },
+    ],
+  };
+
+  _methods = this._defineMethods();
+
+  _context = this._createContext();
+
+  _dataSourceConfig = this._defineDataSourceConfig();
+  _dataSourceEngine = __$$createDataSourceEngine(this._dataSourceConfig, this._context, {
+    runtimeConfig: true,
+    requestHandlersMap: {
+      urlParams: __$$createUrlParamsRequestHandler(this.props.location.search),
+      fetch: __$$createFetchRequestHandler(),
+    },
+  });
+
+  _utils = this._defineUtils();
+
+  _lifeCycles = this._defineLifeCycles();
+
+  componentDidMount() {
+    this._dataSourceEngine.reloadDataSource();
+
+    this._lifeCycles.didMount();
+  }
+
+  componentWillUnmount() {
+    this._lifeCycles.willUnmount();
+  }
+
+  render() {
+    const __$$context = this._context;
+    const {
+      state,
+      setState,
+      dataSourceMap,
+      reloadDataSource,
+      utils,
+      constants,
+      i18n,
+      i18nFormat,
+      getLocale,
+      setLocale,
+    } = __$$context;
+
+    return (
+      <View>
+        <View>
+          <Text>Demo data source logic</Text>
+        </View>
+        <View>
+          <Text>=== User Info: ===</Text>
+        </View>
+        {__$$eval(() => __$$context.state.user) && (
+          <View style={{ flexDirection: 'row' }}>
+            <Image
+              source={{ uri: __$$eval(() => __$$context.state.user.avatar) }}
+              style={{ width: '32px', height: '32px' }}
+            />
+            <View onClick={__$$context.hello}>
+              <Text>{__$$eval(() => __$$context.state.user.name)}</Text>
+              <Text>{__$$eval(() => __$$context.state.user.age)}岁</Text>
+            </View>
+          </View>
+        )}
+        <View>
+          <Text>=== Orders: ===</Text>
+        </View>
+        {__$$evalArray(() => __$$context.state.orders).map((order, index) => (
+          <View
+            style={{ flexDirection: 'row' }}
+            data-order={order}
+            onClick={(...__$$args) => {
+              if (__$$isMiniApp) {
+                const __$$event = __$$args[0];
+                const order = __$$event.target.dataset.order;
+                return function () {
+                  __$$context.utils.recordEvent(`CLICK_ORDER`, order.title);
+                }.apply(this, __$$args);
+              } else {
+                return function () {
+                  __$$context.utils.recordEvent(`CLICK_ORDER`, order.title);
+                }.apply(this, __$$args);
+              }
+            }}
+          >
+            <View>
+              <Image source={{ uri: __$$eval(() => order.coverUrl) }} style={{ width: '80px', height: '60px' }} />
+            </View>
+            <View>
+              <Text>{__$$eval(() => order.title)}</Text>
+              <Text>{__$$eval(() => __$$context.utils.formatPrice(order.price, '元'))}</Text>
+            </View>
+          </View>
+        ))}
+        <View
+          onClick={function () {
+            __$$context.setState({
+              clickCount: __$$context.state.clickCount + 1,
+            });
+          }}
+        >
+          <Text>点击次数：{__$$eval(() => __$$context.state.clickCount)}(点击加 1)</Text>
+        </View>
+        <View>
+          <Text>操作提示：</Text>
+          <Text>1. 点击会员名，可以弹出 Toast "Hello xxx!"</Text>
+          <Text>2. 点击订单，会记录点击的订单信息，并弹出 Toast 提示</Text>
+          <Text>3. 最下面的【点击次数】，点一次应该加 1</Text>
+        </View>
+      </View>
+    );
+  }
+
+  _createContext() {
+    const self = this;
+
+    // 保存下最新的状态，这样 setState 可以搞成同步一样的了
+    self._latestState = self.state;
+
+    const context = {
+      get state() {
+        // 这里直接获取最新的 state，从而能避免一些 React/Rax 这样的框架因为异步 setState 而导致的一些问题
+        return self._latestState;
+      },
+      setState(newState) {
+        self._latestState = { ...self._latestState, ...newState };
+        self.setState(newState);
+      },
+      get dataSourceMap() {
+        return self._dataSourceEngine.dataSourceMap || {};
+      },
+      async reloadDataSource() {
+        await self._dataSourceEngine.reloadDataSource();
+      },
+      get utils() {
+        return self._utils;
+      },
+      get page() {
+        return context;
+      },
+      get component() {
+        return context;
+      },
+      get props() {
+        return self.props;
+      },
+      get constants() {
+        return __$$constants;
+      },
+      i18n: __$$i18n.i18n,
+      i18nFormat: __$$i18n.i18nFormat,
+      getLocale: __$$i18n.getLocale,
+      setLocale(locale) {
+        __$$i18n.setLocale(locale);
+        self.forceUpdate();
+      },
+      ...this._methods,
+    };
+
+    return context;
+  }
+
+  _defineDataSourceConfig() {
+    const __$$context = this._context;
+    return {
+      list: [
+        {
+          id: 'urlParams',
+          type: 'urlParams',
+          isInit: function () {
+            return undefined;
+          },
+          options: function () {
+            return undefined;
+          },
+        },
+        {
+          id: 'user',
+          type: 'fetch',
+          options: function () {
+            return {
+              method: 'GET',
+              uri: 'https://shs.alibaba-inc.com/mock/1458/demo/user',
+              isSync: true,
+            };
+          },
+          dataHandler: function (response) {
+            if (!response.success) {
+              throw new Error(response.message);
+            }
+
+            return response.data;
+          },
+          isInit: function () {
+            return undefined;
+          },
+        },
+        {
+          id: 'orders',
+          type: 'fetch',
+          options: function () {
+            return {
+              method: 'GET',
+              uri: __$$context.state.user.ordersApiUri,
+              isSync: true,
+            };
+          },
+          dataHandler: function (response) {
+            if (!response.success) {
+              throw new Error(response.message);
+            }
+
+            return response.data.result;
+          },
+          isInit: function () {
+            return undefined;
+          },
+        },
+      ],
+      dataHandler: function (dataMap) {
+        console.info('All datasources loaded:', dataMap);
+      },
+    };
+  }
+
+  _defineUtils() {
+    const utils = {
+      ...__$$projectUtils,
+    };
+
+    Object.entries(utils).forEach(([name, util]) => {
+      if (typeof util === 'function') {
+        utils[name] = util.bind(this._context);
+      }
+    });
+
+    return utils;
+  }
+
+  _defineLifeCycles() {
+    const __$$lifeCycles = {
+      didMount: function didMount() {
+        this.utils.Toast.show(`Hello ${this.state.user.name}!`);
+      },
+
+      willUnmount: function didMount() {
+        this.utils.Toast.show(`Bye, ${this.state.user.name}!`);
+      },
+    };
+
+    // 为所有的方法绑定上下文
+    Object.entries(__$$lifeCycles).forEach(([lifeCycleName, lifeCycleMethod]) => {
+      if (typeof lifeCycleMethod === 'function') {
+        __$$lifeCycles[lifeCycleName] = (...args) => {
+          return lifeCycleMethod.apply(this._context, args);
+        };
+      }
+    });
+
+    return __$$lifeCycles;
+  }
+
+  _defineMethods() {
+    const __$$methods = {
+      hello: function hello() {
+        this.utils.Toast.show(`Hello ${this.state.user.name}!`);
+        console.log(`Hello ${this.state.user.name}!`);
+      },
+    };
+
+    // 为所有的方法绑定上下文
+    Object.entries(__$$methods).forEach(([methodName, method]) => {
+      if (typeof method === 'function') {
+        __$$methods[methodName] = (...args) => {
+          return method.apply(this._context, args);
+        };
+      }
+    });
+
+    return __$$methods;
+  }
+}
+
+export default __$$withRouter(Home$$Page);
+
+function __$$eval(expr) {
+  try {
+    return expr();
+  } catch (err) {
+    console.warn('Failed to evaluate: ', expr, err);
+  }
+}
+
+function __$$evalArray(expr) {
+  const res = __$$eval(expr);
+  return Array.isArray(res) ? res : [];
+}
diff --git a/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/utils.js b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/utils.js
new file mode 100644
index 000000000..a9612b3d2
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo2/expected/demo-project/src/utils.js
@@ -0,0 +1,26 @@
+import moment from 'moment';
+
+import clone from 'lodash/clone';
+
+import Toast from 'universal-toast';
+
+const formatPrice = function formatPrice(price, unit) {
+  return Number(price).toFixed(2) + unit;
+};
+
+const recordEvent = function recordEvent(eventName, eventDetail) {
+  this.utils.Toast.show(`[EVENT]: ${eventName} ${eventDetail}`);
+  console.log(`[EVENT]: ${eventName} (detail: %o) (user: %o)`, eventDetail, this.state.user);
+};
+
+export default {
+  formatPrice,
+
+  recordEvent,
+
+  moment,
+
+  clone,
+
+  Toast,
+};
diff --git a/packages/code-generator/test-cases/rax-app/demo2/schema.json5 b/packages/code-generator/test-cases/rax-app/demo2/schema.json5
new file mode 100644
index 000000000..a9f5813cd
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo2/schema.json5
@@ -0,0 +1,375 @@
+{
+  // 本例是一个比较复杂的，带有循环和条件渲染的，以及有各种事件处理函数的页面
+  // Schema 参见：https://yuque.antfin-inc.com/mo/spec/spec-materials#eNCJr
+  version: '1.0.0',
+  componentsMap: [
+    {
+      componentName: 'View',
+      package: 'rax-view',
+      version: '^1.0.0',
+      destructuring: false,
+      exportName: 'View',
+    },
+    {
+      componentName: 'Text',
+      package: 'rax-text',
+      version: '^1.0.0',
+      destructuring: false,
+      exportName: 'Text',
+    },
+    {
+      componentName: 'Image',
+      package: 'rax-image',
+      version: '^1.0.0',
+      destructuring: false,
+      exportName: 'Image',
+    },
+    {
+      componentName: 'Page',
+      package: 'rax-view',
+      version: '^1.0.0',
+      destructuring: false,
+      exportName: 'Page',
+    },
+  ],
+  componentsTree: [
+    {
+      componentName: 'Page',
+      fileName: 'home',
+      meta: {
+        router: '/',
+      },
+      state: {
+        clickCount: 0,
+        user: { name: '张三', age: 18, avatar: 'https://gw.alicdn.com/tfs/TB1Ui9BMkY2gK0jSZFgXXc5OFXa-50-50.png' },
+        orders: [
+          {
+            title: '【小米智能生活】米家扫地机器人家用全自动扫拖一体机拖地吸尘器',
+            price: 1799,
+            coverUrl: 'https://gw.alicdn.com/tfs/TB1dGVlRfb2gK0jSZK9XXaEgFXa-258-130.png',
+          },
+          {
+            title: '【限时下单立减】Apple/苹果 iPhone 11 4G全网通智能手机正品苏宁易购官方旗舰店苹果11',
+            price: 4999,
+            coverUrl: 'https://gw.alicdn.com/tfs/TB18gdJddTfau8jSZFwXXX1mVXa-1298-1202.png',
+          },
+        ],
+      },
+      props: {},
+      lifeCycles: {
+        didMount: {
+          type: 'JSExpression',
+          value: 'function didMount(){\n  this.utils.Toast.show(`Hello ${this.state.user.name}!`);\n}',
+        },
+        willUnmount: {
+          type: 'JSExpression',
+          value: 'function didMount(){\n  this.utils.Toast.show(`Bye, ${this.state.user.name}!`);\n}',
+        },
+      },
+      methods: {
+        hello: {
+          type: 'JSExpression',
+          value: 'function hello(){\n  this.utils.Toast.show(`Hello ${this.state.user.name}!`);\n  console.log(`Hello ${this.state.user.name}!`); }',
+        },
+      },
+      dataSource: {
+        list: [
+          {
+            id: 'urlParams',
+            type: 'urlParams',
+          },
+          // 示例数据源：https://shs.alibaba-inc.com/mock/1458/demo/user
+          {
+            id: 'user',
+            type: 'fetch',
+            options: {
+              method: 'GET',
+              uri: 'https://shs.alibaba-inc.com/mock/1458/demo/user',
+              isSync: true,
+            },
+            dataHandler: {
+              type: 'JSExpression',
+              value: 'function (response) {\nif (!response.success){\n    throw new Error(response.message);\n  }\n  return response.data;\n}',
+            },
+          },
+          // 示例数据源：https://shs.alibaba-inc.com/mock/1458/demo/orders
+          {
+            id: 'orders',
+            type: 'fetch',
+            options: {
+              method: 'GET',
+              uri: {
+                type: 'JSExpression',
+                value: 'this.state.user.ordersApiUri',
+              },
+              isSync: true,
+            },
+            dataHandler: {
+              type: 'JSExpression',
+              value: 'function (response) {\nif (!response.success){\n    throw new Error(response.message);\n  }\n  return response.data.result;\n}',
+            },
+          },
+        ],
+        dataHandler: {
+          type: 'JSExpression',
+          value: 'function (dataMap) {\n  console.info("All datasources loaded:", dataMap);\n}',
+        },
+      },
+      children: [
+        {
+          componentName: 'View',
+          children: [
+            {
+              componentName: 'Text',
+              props: {},
+              children: 'Demo data source logic',
+            },
+          ],
+        },
+        {
+          componentName: 'View',
+          children: [
+            {
+              componentName: 'Text',
+              props: {},
+              children: '=== User Info: ===',
+            },
+          ],
+        },
+        {
+          componentName: 'View',
+          condition: {
+            type: 'JSExpression',
+            value: 'this.state.user',
+          },
+          props: {
+            style: { flexDirection: 'row' },
+          },
+          children: [
+            {
+              componentName: 'Image',
+              props: {
+                source: {
+                  uri: {
+                    type: 'JSExpression',
+                    value: 'this.state.user.avatar',
+                  },
+                },
+                style: {
+                  width: '32px',
+                  height: '32px',
+                },
+              },
+            },
+            {
+              componentName: 'View',
+              props: {
+                onClick: {
+                  type: 'JSExpression',
+                  value: 'this.hello',
+                },
+              },
+              children: [
+                {
+                  componentName: 'Text',
+                  children: {
+                    type: 'JSExpression',
+                    value: 'this.state.user.name',
+                  },
+                },
+                {
+                  componentName: 'Text',
+                  children: [
+                    {
+                      type: 'JSExpression',
+                      value: 'this.state.user.age',
+                    },
+                    '岁',
+                  ],
+                },
+              ],
+            },
+          ],
+        },
+        {
+          componentName: 'View',
+          children: [
+            {
+              componentName: 'Text',
+              props: {},
+              children: '=== Orders: ===',
+            },
+          ],
+        },
+        {
+          componentName: 'View',
+          loop: {
+            type: 'JSExpression',
+            value: 'this.state.orders',
+          },
+          loopArgs: ['order', 'index'],
+          props: {
+            style: { flexDirection: 'row' },
+            onClick: {
+              type: 'JSExpression',
+              value: 'function(){ this.utils.recordEvent(`CLICK_ORDER`, this.order.title) }',
+            },
+          },
+          children: [
+            {
+              componentName: 'View',
+              children: [
+                {
+                  componentName: 'Image',
+                  props: {
+                    source: {
+                      uri: {
+                        type: 'JSExpression',
+                        value: 'this.order.coverUrl',
+                      },
+                    },
+                    style: {
+                      width: '80px',
+                      height: '60px',
+                    },
+                  },
+                },
+              ],
+            },
+            {
+              componentName: 'View',
+              children: [
+                {
+                  componentName: 'Text',
+                  children: {
+                    type: 'JSExpression',
+                    value: 'this.order.title',
+                  },
+                },
+                {
+                  componentName: 'Text',
+                  children: {
+                    type: 'JSExpression',
+                    value: 'this.utils.formatPrice(this.order.price, "元")',
+                  },
+                },
+              ],
+            },
+          ],
+        },
+        {
+          componentName: 'View',
+          props: {
+            onClick: {
+              type: 'JSExpression',
+              value: 'function (){ this.setState({ clickCount: this.state.clickCount + 1 }) }',
+            },
+          },
+          children: [
+            {
+              componentName: 'Text',
+              children: [
+                '点击次数：',
+                {
+                  type: 'JSExpression',
+                  value: 'this.state.clickCount',
+                },
+                '(点击加 1)',
+              ],
+            },
+          ],
+        },
+        {
+          componentName: 'View',
+          children: [
+            {
+              componentName: 'Text',
+              props: {},
+              children: '操作提示：',
+            },
+            {
+              componentName: 'Text',
+              props: {},
+              children: '1. 点击会员名，可以弹出 Toast "Hello xxx!"',
+            },
+            {
+              componentName: 'Text',
+              props: {},
+              children: '2. 点击订单，会记录点击的订单信息，并弹出 Toast 提示',
+            },
+            {
+              componentName: 'Text',
+              props: {},
+              children: '3. 最下面的【点击次数】，点一次应该加 1',
+            },
+          ],
+        },
+      ],
+    },
+  ],
+  utils: [
+    // 可以直接定义一个函数
+    {
+      name: 'formatPrice',
+      type: 'function',
+      content: {
+        type: 'JSExpression',
+        value: 'function formatPrice(price, unit) { return Number(price).toFixed(2) + unit; }',
+      },
+    },
+    // 在 utils 里面也可以用 this 访问当前上下文:
+    {
+      name: 'recordEvent',
+      type: 'function',
+      content: {
+        type: 'JSExpression',
+        value: 'function recordEvent(eventName, eventDetail) { \n  this.utils.Toast.show(`[EVENT]: ${eventName} ${eventDetail}`);\n  console.log(`[EVENT]: ${eventName} (detail: %o) (user: %o)`, eventDetail, this.state.user); }',
+      },
+    },
+    // 也可以直接从 npm 包引入 (下例等价于 `import moment from 'moment';`)
+    {
+      name: 'moment',
+      type: 'npm',
+      content: {
+        package: 'moment',
+        version: '*',
+        exportName: 'moment',
+      },
+    },
+    // 可以引入子目录（下例等价于 `import clone from 'lodash/clone';`)
+    {
+      name: 'clone',
+      type: 'npm',
+      content: {
+        package: 'lodash',
+        version: '*',
+        exportName: 'clone',
+        destructuring: false,
+        main: '/clone',
+      },
+    },
+    {
+      name: 'Toast',
+      type: 'npm',
+      content: {
+        package: 'universal-toast',
+        version: '^1.2.0',
+        exportName: 'Toast', // TODO: 这个 exportName 是否可以省略？省略后默认是上一层的 name？
+      },
+    },
+  ],
+  css: 'page,body{\n  width: 750rpx;\n  overflow-x: hidden;\n}',
+  config: {
+    sdkVersion: '1.0.3',
+    historyMode: 'hash',
+    targetRootID: 'root',
+  },
+  meta: {
+    name: 'Rax App Demo',
+    git_group: 'demo-group',
+    project_name: 'demo-project',
+    description: '这是一个示例应用',
+    spma: 'spmademo',
+    creator: '张三',
+  },
+}
diff --git a/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/.editorconfig b/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/.editorconfig
new file mode 100644
index 000000000..5760be583
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/.editorconfig
@@ -0,0 +1,12 @@
+# http://editorconfig.org
+root = true
+
+[*]
+indent_style = space
+indent_size = 2
+charset = utf-8
+trim_trailing_whitespace = true
+insert_final_newline = true
+
+[*.md]
+trim_trailing_whitespace = false
diff --git a/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/.eslintignore b/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/.eslintignore
new file mode 100644
index 000000000..3b437e614
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/.eslintignore
@@ -0,0 +1,11 @@
+# 忽略目录
+build/
+tests/
+demo/
+
+# node 覆盖率文件
+coverage/
+
+# 忽略文件
+**/*-min.js
+**/*.min.js
diff --git a/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/.eslintrc.js b/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/.eslintrc.js
new file mode 100644
index 000000000..e2a7c5b54
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/.eslintrc.js
@@ -0,0 +1,3 @@
+module.exports = {
+  extends: ['rax'],
+};
diff --git a/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/.gitignore b/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/.gitignore
new file mode 100644
index 000000000..50a53dace
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/.gitignore
@@ -0,0 +1,17 @@
+# See https://help.github.com/articles/ignoring-files/ for more about ignoring files.
+
+*~
+*.swp
+*.log
+
+.DS_Store
+.idea/
+.temp/
+
+build/
+dist/
+lib/
+coverage/
+node_modules/
+
+template.yml
diff --git a/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/src/app.js b/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/src/app.js
new file mode 100644
index 000000000..bc474c6e3
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/src/app.js
@@ -0,0 +1,6 @@
+import { runApp } from 'rax-app';
+import appConfig from './app.json';
+
+import './global.scss';
+
+runApp(appConfig);
diff --git a/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/src/constants.js b/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/src/constants.js
new file mode 100644
index 000000000..ea766c9da
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo3/expected/demo-project/src/constants.js
@@ -0,0 +1,3 @@
+const __$$constants = {};
+
+export default __$$constants;
